<template>
  <div>
    <validation-observer v-slot="{ handleSubmit }">
      <form @submit.prevent="handleSubmit(onSubmit)">
        <div class="form-input px-5 py-3">
          <div class="row mb-2">
            <div class="form-group col-md-12 d-flex">
              <div class="d-flex lable-input">
                <font-awesome-icon fas icon="user" />
                <label for="inputName" class="form-label ml-2">Name</label>
              </div>
              <validation-provider
                name="Name"
                rules="required|max:255|min:2"
                v-slot="{ errors }"
                class="w-100"
              >
                <input
                  type="text"
                  class="form-control"
                  id="inputName"
                  placeholder="UserName"
                  v-model="user.name"
                />
                <span class="d-flex" style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
            <div class="form-group col-md-12 d-flex">
              <div class="d-flex lable-input">
                <font-awesome-icon fas icon="phone-square" />
                <label for="inputPhone" class="form-label ml-2">Phone</label>
              </div>
              <validation-provider
                name="Phone"
                rules="required|max:12|min:10"
                v-slot="{ errors }"
                class="w-100"
              >
                <input
                  type="text"
                  class="form-control"
                  id="inputPhone"
                  placeholder="+84123456789"
                  v-model="user.phone"
                />
                <span style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
          </div>
          <div class="row mb-2">
            <div class="form-group col-md-12 d-flex">
              <div class="d-flex lable-input lable-input">
                <font-awesome-icon fas icon="envelope" />
                <label for="inputEmail" class="form-label ml-2">Email</label>
              </div>
              <validation-provider
                name="Email"
                rules="required|email"
                v-slot="{ errors }"
                class="w-100"
              >
                <input
                  type="email"
                  class="form-control"
                  id="inputEmail"
                  placeholder="user@example.com"
                  v-model="user.email"
                />
                <span style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
            <div v-if="!idUser" class="form-group col-md-12 d-flex">
              <div class="d-flex lable-input">
                <font-awesome-icon fas icon="lock" />
                <label for="inputPassword" class="form-label ml-2"
                  >Password</label
                >
              </div>

              <validation-provider
                name="Password"
                rules="required|min:6"
                v-slot="{ errors }"
                class="w-100"
              >
                <input
                  type="password"
                  class="form-control"
                  id="inputPassword"
                  placeholder="******"
                  v-model="user.password"
                />
                <span style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
            <div v-if="!idUser" class="form-group col-md-12 d-flex">
              <div class="d-flex lable-input">
                <font-awesome-icon fas icon="lock" />
                <label for="inputR-Password" class="form-label ml-2"
                  >R-Password</label
                >
              </div>

              <validation-provider
                name="R-Password"
                rules="min:6|confirmed:@password"
                v-slot="{ errors }"
                class="w-100"
              >
                <input
                  type="password"
                  class="form-control"
                  id="inputR-Password"
                  placeholder="******"
                />
                <span style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
          </div>
          <div class="row mb-2">
            <div class="form-group col-md-12 d-flex">
              <div class="d-flex lable-input">
                <font-awesome-icon fas icon="map-marker-alt" />
                <label for="inputAddress" class="form-label ml-2"
                  >Address</label
                >
              </div>
              <validation-provider
                name="Address"
                rules="required|max:255"
                v-slot="{ errors }"
                class="w-100"
              >
                <input
                  type="text"
                  class="form-control"
                  id="inputAddress"
                  placeholder="Đống Đa- Hà Nội"
                  v-model="user.address"
                />
                <span style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
            <div class="form-group col-md-12 d-flex">
              <div class="d-flex lable-input">
                <font-awesome-icon fas icon="birthday-cake" />
                <label for="inputBirthday" class="form-label ml-2"
                  >Birthday</label
                >
              </div>
              <validation-provider
                name="Birthday"
                rules="required"
                v-slot="{ errors }"
                class="w-100"
              >
                <input
                  type="date"
                  class="form-control"
                  id="inputBirthday"
                  v-model="user.birthday"
                />
                <span style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
          </div>
          <div class="row mb-2">
            <div class="form-group col-md-12 d-flex">
              <div class="d-flex lable-input">
                <font-awesome-icon fas icon="venus-mars" />

                <label class="form-label ml-2">Gender</label>
              </div>
              <validation-provider
                name="Gender"
                rules="required"
                v-slot="{ errors }"
                class="w-100"
              >
                <div class="d-flex">
                  <div class="form-check ml-0">
                    <input
                      class="form-check-input"
                      type="radio"
                      name="flexRadioGender"
                      id="flexRadioGender1"
                      :value="0"
                      v-model="user.gender"
                    />
                    <label class="form-check-label" for="flexRadioGender1">
                      Nam
                    </label>
                  </div>
                  <div class="form-check">
                    <input
                      class="form-check-input"
                      type="radio"
                      name="flexRadioGender"
                      id="flexRadioGender2"
                      :value="1"
                      v-model="user.gender"
                    />
                    <label class="form-check-label" for="flexRadioGender2">
                      Nữ
                    </label>
                  </div>
                </div>
                <span style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
            <div class="form-group col-md-12 d-flex">
              <div class="d-flex lable-input">
                <font-awesome-icon fas icon="user-tag" />
                <label class="form-label ml-2">Role</label>
              </div>

              <validation-provider
                name="Role"
                rules="required"
                v-slot="{ errors }"
                class="w-100"
              >
                <div class="d-flex">
                  <div class="form-check ml-0">
                    <input
                      class="form-check-input"
                      type="radio"
                      name="flexRadioRole"
                      id="flexRadioRole1"
                      :value="0"
                      v-model="user.roles"
                    />
                    <label class="form-check-label" for="flexRadioRole1">
                      Management
                    </label>
                  </div>
                  <div class="form-check">
                    <input
                      class="form-check-input"
                      type="radio"
                      name="flexRadioRole"
                      id="flexRadioRole2"
                      :value="1"
                      v-model="user.roles"
                    />
                    <label class="form-check-label" for="flexRadioRole2">
                      Menber
                    </label>
                  </div>
                </div>
                <span style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
          </div>
          <div class="row mb-2">
            <div class="form-group d-flex">
              <div class="d-flex lable-input">
                <font-awesome-icon fas icon="users" />
                <label for="selectTeam" class="form-label ml-2">Team</label>
              </div>
              <validation-provider
                name="Team"
                rules="oneOf:1,2,3"
                v-slot="{ errors }"
                class="w-100"
              >
                <select
                  class="form-select"
                  id="selectTeam"
                  v-model="user.team_id"
                >
                  <option
                    v-for="(team_id, index) in listTeam"
                    :key="index"
                    :value="team_id.id"
                  >
                    {{ team_id.name }}
                  </option>
                </select>
                <span style="color: red">{{ errors[0] }}</span>
              </validation-provider>
            </div>
          </div>
          <div class="row mb-2"></div>
        </div>
        <div class="form-submit">
          <div class="form-group text-center p-3">
            <button class="btn btn-primary">Save</button>
            <button class="btn btn-secondary" data-dismiss="modal">
              Close
            </button>
          </div>
        </div>
      </form>
    </validation-observer>
  </div>
</template>

<script>
import { API_TEAM, API_USER } from '~/assets/contants/contant.js'
import { toHtml } from '~/node_modules/@fortawesome/fontawesome-svg-core'
export default {
  data() {
    return {
      listTeam: [],
      user: {
        name: '',
        email: '',
        phone: '',
        address: '',
        birthday: '',
        gender: '',
        roles: '',
        team_id: 0,
        avatar: '',
      },
    }
  },
  props: {
    idUser: {
      type: Number,
    },
  },
  methods: {
    async onSubmit() {
      $('#createUpdateModal').modal('hide')
      // Form edit
      if (this.idUser) {
        try {
          await this.$axios.$put(API_USER + this.idUser, this.user)
          this.$emit('on-edit-user-success')
        } catch (err) {
          console.log(err)
        }
      }
      // Form new
      else {
        try {
          await this.$axios.$post(API_USER, this.user)
          this.$emit('on-create-user-success')
        } catch (err) {
          console.log(err)
        }
      }
    },
    async getUserById() {
      this.user = await this.$axios.$get(API_USER + this.idUser)
    },
    async getListTeam() {
      this.listTeam = await this.$axios.$get(API_TEAM)
    },
  },
  mounted() {
    this.getUserById()
    this.getListTeam()
  },
  watch: {
    idUser() {
      if (this.idUser) {
        this.getUserById()
      } else {
        this.user = {}
      }
    },
  },
}
</script>

<style>
.form-submit {
  border-top: 1px solid rgba(0, 0, 0, 0.125);
}
.form-check {
  margin-left: 1rem;
}
.lable-input {
  margin-right: 1.5rem;
  margin-top: 0.4rem;
  align-items: baseline;
  width: 80px;
}
.lable-input {
  margin-right: 1.5rem;
  margin-top: 0.4rem;
  align-items: baseline;
  width: 110px;
}
</style>
